(define-module (kulupu tests utils)
  #:use-module (gnu)
  #:use-module (gnu services databases)
  #:use-module (gnu services networking)
  #:use-module (gnu packages databases)
  #:use-module (gnu services ssh)
  #:use-module (gnu services certbot)
  #:use-module (gnu services web)
  #:use-module (gnu packages linux)
  #:use-module (gnu packages ssh)
  #:use-module (kulupu services gotosocial))

(define %base-container-services
  (cons
   (service static-networking-service-type
            (list (static-networking
                   (addresses
                    (list (network-address
                           (device "veth")
                           (value "10.0.0.2/24"))))
                   (routes
                    (list (network-route
                           (destination "default")
                           (gateway "10.0.0.1")))))))
   %base-services))

(define-public %container-system
  (operating-system
    (kernel linux-libre-lts)
    (host-name "localhost")
    (bootloader (bootloader-configuration
                 (bootloader grub-bootloader)
                 (targets '("/dev/sdX"))))
    ;; It's fitting to support the equally bare bones ‘-nographic’
    ;; QEMU option, which also nicely sidesteps forcing QWERTY.
    (kernel-arguments (list "console=ttyS0,115200"))
    (file-systems (cons (file-system
                          (device (file-system-label "my-root"))
                          (mount-point "/")
                          (type "ext4"))
                        %base-file-systems))
    (services %base-container-services)))

(define-public %gotosocial-container
  (operating-system
    (inherit %container-system)
    (services (cons*
               (service certbot-service-type
                        (certbot-configuration
                         (email "test@test.com")))
               (service nginx-service-type)
               (service postgresql-service-type
                        (postgresql-configuration
                         (postgresql postgresql-10)))
                (service gotosocial-service-type)
                %base-container-services))))

%gotosocial-container
